;;; so-long.el --- simple save-buffers-kill-emacs.
;;; $Id: so-long.el,v 1.8 2006/10/02 08:16:21 xia Exp $

;; Author: Taka Ogawa <xia@mule.club.ne.jp>

;;; Commentary:
;; 必ず一度だけ yes-or-no-p する save-buffers-kill-emacs もどき。

;;; Code:
(defun so-long (&optional arg)
  (interactive "P")
  (when arg
    (save-some-buffers t t))

  (let ((modified-buffer-list
	 (delq nil (mapcar
		    (lambda (buf)
		      (when (and (buffer-file-name buf)
				 (buffer-modified-p buf))
			buf))
		    (buffer-list))))
	(active-process-list
	 (delq nil (mapcar
		    (lambda (proc)
		      (and (memq (process-status proc) '(run stop open))
			   (let ((val (process-kill-without-query proc)))
			     (process-kill-without-query proc val)
			     (when val
			       proc))))
		    (process-list)))))
    (when (yes-or-no-p
	   (cond
	    ((and modified-buffer-list active-process-list)
	     "Modified buffers and active processes exist; exit anyway? ")
	    (modified-buffer-list
	     "Modified buffers exist; exit anyway? ")
	    (active-process-list
	     "Active processes exist; exit anyway? ")
	    (t
	     "Exit? ")))
      (and
       (run-hook-with-args-until-failure 'kill-emacs-query-functions)
       (kill-emacs)))))

(provide 'so-long)

;;; so-long.el ends here
